/** @file ccp_coverage.h
 *
 * @author Alexander Kamkin (kamkin@ispras.ru)
 */

#pragma once

#include <hw/model.hpp>
#include <ts/coverage.hpp>
#include <tracer/tracer.hpp>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer;
using namespace cpptesk::tracer::coverage;

namespace cpptesk {
namespace examples {
namespace ccp {

class CacheCoherenceModel;

/// Model-based coverage
class CacheCoherenceCoverage {
public:
    CacheCoherenceCoverage(CacheCoherenceModel &ccp): ccp(ccp) {}
   ~CacheCoherenceCoverage() {}

    ENUM_COV(CCP_COVERAGE, "CCP Coverage",
    (
        (OK, "OK")
    ));

    /// Calculates a test situation.
    CCP_COVERAGE cov(void) const;

    /// Traces a test situation.
    void track_cov(void);

private:
    CacheCoherenceModel &ccp;
    CoverageTracker coverageTracker;
};

}}} // namespace cpptesk::examples::ccp
