/*
 * Generated by veritool: Copyright (c) 2009-2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 */

#include <vpi_systf.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include <ts/scenario.h>
#include <utils/testreg.h>
#include <sync.h>

/* Create new source file with code like this:

   #include <utils/testreg.h>

   extern TestScenario example1_scen;
   extern TestScenario example2_scen;
   ClassOfScenario example3_scen;

   TEST_REGISTRY_BEGIN
   REGISTER_CTESK_TEST(example1_scen, engine::fsm, "")
   REGISTER_CTESK_TEST(example2_scen, engine::rnd, "")
   REGISTER_TEST(example3_scen, engine::rnd, NULL)
   TEST_REGISTRY_END
*/

#define SCEN_ARGV_LENGTH 1024
char scen_argv[SCEN_ARGV_LENGTH];

static TestScenario *ctest;

#ifdef __cplusplus
static cpptesk::ts::CppTestScenario *cpptest;
#endif // __cplusplus
static int startscen(bool netscen, char *scen, char *scen_params)
{
    while(isblank(scen[0])) scen++;

    /* Erase blank symbols at the begin of scen_params */
    int position = 0;
    while(isblank(scen_params[position])) position++;
        memmove(scen_params, scen_params + position, strlen(scen_params) - position + 1);

    /* This code looks for item in test registry where scenario is named *scen.
       Don't forget to create the registry! */
    int i;
    for(i = 0; test_registry[i].testName; i++) {
        if(!strcmp(scen, test_registry[i].testName)) {
            int length_local = test_registry[i].testParams == NULL ? 0 : strlen(test_registry[i].testParams),
                length_global = strlen(scen_params);

            if(length_local > 0) {
                assert(length_local + length_global < SCEN_ARGV_LENGTH - 1);
                memmove(scen_params + length_local + 1, scen_params, length_global);
                memmove(scen_params, test_registry[i].testParams, length_local);
                scen_params[length_local] = ' ';
            }

            break;
        }
    }

    assert(test_registry[i].testName != NULL);
    assert(test_registry[i].testScenario != NULL);
    assert(test_registry[i].testEngine != NULL);

    if(test_registry[i].testType == CTESK) {
        ctest = (TestScenario*)test_registry[i].testScenario;
        set_scenario_wrapper(ctest, test_registry[i].testEngine, scen_params, netscen);
        return start_scenario_with_wrapper(scenario_wrapper);
    }
#ifdef __cplusplus
    else if(test_registry[i].testType == CPPTESK) {
        cpptest = ((cpptesk::ts::ScenarioBase*)test_registry[i].testScenario)->getTestScenario();
        set_scenario_wrapper(cpptest, test_registry[i].testEngine, scen_params, netscen);
        return start_scenario_with_wrapper(scenario_wrapper_cpp);
    }
#endif // __cplusplus
    else {
        assert(false);
        return 1;
    }
}

////////////////////////////////////////////////////////////////////////////////
// VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
static int calltf_set_scenario(char *user_data)
{
    s_vpi_value value;
    vpiHandle obj = vpi_handle(vpiSysTfCall, NULL);

    if(user_data) {}

    assert(obj != NULL);

    if(obj != NULL)
    {
        bool netscen = false;
        vpiHandle itr = vpi_iterate(vpiArgument, obj);

        vpiHandle arg = vpi_scan(itr);
        value.format = vpiStringVal;
        vpi_get_value(arg, &value);
        if(*value.value.str == 1)
            netscen = true;

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);
        strcpy(scen_argv, value.value.str);

        arg = vpi_scan(itr);
        vpi_get_value(arg, &value);

        vpi_free_object(obj);
        vpi_free_object(itr);
        vpi_free_object(arg);

        return startscen(netscen, value.value.str, scen_argv);
    }

    return 0;
}

static int calltf_apply_action(char *user_data)
{
    if(user_data) {}
    return 0;
}

static int calltf_check_action(char *user_data)
{
    if(user_data) {}
    apply_check();
    return 0;
}

////////////////////////////////////////////////////////////////////////////////
// Registration of VPI Tasks and Functions
////////////////////////////////////////////////////////////////////////////////
static void register_calltf_set_scenario(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_SET_SCENARIO;
    tf_data.calltf      = calltf_set_scenario;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

static void register_calltf_apply_action(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_APPLY_ACTION;
    tf_data.calltf      = calltf_apply_action;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

static void register_calltf_check_action(void)
{
    s_vpi_systf_data tf_data;
    #ifdef IEEE_1364_2001
        vpiHandle tf_handle;
    #endif

    tf_data.type        = vpiSysTask;
    tf_data.sysfunctype = 0;
    tf_data.tfname      = TF_NAME_CHECK_ACTION;
    tf_data.calltf      = calltf_check_action;
    tf_data.compiletf   = NULL;
    tf_data.sizetf      = NULL;
    tf_data.user_data   = NULL;

    #ifndef IEEE_1364_2001
        vpi_register_systf(&tf_data);
    #else
        tf_handle = vpi_register_systf(&tf_data);
        vpi_free_object(tf_handle);
    #endif
}

void (*vlog_startup_routines[])(void) =
{
    register_calltf_set_scenario,
    register_calltf_apply_action,
    register_calltf_check_action,
    NULL
};

