/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Kamkin (kamkin@ispras.ru)
// SYNOPSIS: Process stack 
///////////////////////////////////////////////////////////////////////////////

#include <hw/stack.hpp>

#include <hw/process.hpp>

namespace cpptesk {
namespace hw {

std::ostream& operator << (std::ostream& out, const process_stack_t &process_stack)
{
    process_stack_t::const_reverse_iterator i;

    // IMPORTANT: Call stack can not be empty
    if(process_stack.empty()) { return out; }

    out << (*(i = process_stack.rbegin()))->call_stack;

    for(++i; i != process_stack.rend(); i++)
        { out << std::endl << (*i)->call_stack; }

    return out;
}

}} // namespace cpptesk::hw

